"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.minimalParser = exports.dashboardTransformer = void 0;

var _lodash = _interopRequireDefault(require("lodash.get"));

var _lodash2 = _interopRequireDefault(require("lodash.set"));

var _jsonTransformerJs = _interopRequireDefault(require("json-transformer-js"));

var _minimalLispParser = require("json-rule-processor/dist/minimal-lisp-parser");

var recompose = _interopRequireWildcard(require("recompose"));

var R = _interopRequireWildcard(require("ramda"));

var dataUtils = _interopRequireWildcard(require("./data-utils"));

var dmUtils = _interopRequireWildcard(require("./dm-utils"));

var uiUtils = _interopRequireWildcard(require("./ui-utils"));

var trUtils = _interopRequireWildcard(require("./transforms"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// import { req, reqEntityConf } from './be-client';
// import { withChannelData } from './withChannelData';
// import { withSub } from './withSub';
// import { withPresence } from './withPresence';
// import { withAsync } from './withAsync';
var defaultStaticContext = {
  // '%': R.modulo,
  tapLog: R.tap(function (x) {
    return console.log('TAPPING:', x);
  }),
  // utils: { ...uiUtils, ...dataUtils, ...dmUtils },
  'utils.dm': dmUtils,
  'utils.ui': uiUtils,
  'utils.data': dataUtils,
  'utils.tr': trUtils // withSub,
  // withPresence,
  // withReq: withAsync(req),
  // connect,
  // stringToElement,
  // req,
  // reqEntityConf,

};
var dashboardTransformer = R.curry(function (_ref) {
  var staticContext = _ref.staticContext,
      transforms = _ref.transforms,
      parserMutator = _ref.parserMutator;
  var vars = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var env = _objectSpread({}, defaultStaticContext, {}, staticContext);

  var parser = (0, _minimalLispParser.functionalParserWithVars)(vars, {
    envExtra: env
  });
  R.forEachObjIndexed(function (func, name) {
    parser["Re.".concat(name)] = func;
  }, recompose);
  if (parserMutator) parserMutator(parser);
  var transformer = (0, _jsonTransformerJs["default"])({
    defaultLevel1Transform: function defaultLevel1Transform(v, k) {
      return (0, _lodash["default"])((0, _lodash2["default"])(vars, k, v), k);
    },
    transforms: _objectSpread({
      '%ml%': function ml(arr) {
        try {
          return parser.evaluate(arr);
        } catch (err) {
          console.error('miniMAL eval:', err);
          return undefined;
        }
      }
    }, transforms)
  });
  return function (json) {
    return json && transformer(json);
  };
});
exports.dashboardTransformer = dashboardTransformer;
var minimalParser = R.curry(function (_ref2, vars) {
  var staticContext = _ref2.staticContext,
      parserMutator = _ref2.parserMutator;
  var parser = (0, _minimalLispParser.functionalParserWithVars)(vars, {
    envExtra: staticContext
  });
  if (parserMutator) parserMutator(parser);
  return function (json) {
    return json && parser.evaluate(json);
  };
});
exports.minimalParser = minimalParser;